;;
;; FILE:     boom.rkt
;; AUTHOR:   Eugene Wallingford
;; DATE:     2020/01/27
;; COMMENT:  A simple module that exports a boom! procedure.
;;

#lang racket

;; -- The following expression "exports" the name boom!.
;; -- We do not have to export all the functions in the file.
;; -- Unexported functions are effectively "private".

(provide boom!)

;; -- The rest of the file is a list of definitions, like
;; -- any other program.

(define boom!
  (lambda ()
    (make-! "boom")))

(define make-!
  (lambda (str)
    (string-append str "!")))

